--====================================================================================
------------------ ALTA D'UN PAQUET D'ACCIONS A LA CARTERA D'UN CLIENT ---------------
--====================================================================================
-- Altes de les accions que posseeixen els clients en la seva cartera dinversions 
-- Hi ha alguns atributs que no es demanen com a parmetres en aquest procediment, aquests sn:
-- les unitats disponibles: perqu en principi sn les mateixes que les unitats 
-- i el camp activasn: que en principi estar actiu
set define off;
CREATE OR REPLACE PROCEDURE PROC_ALTA_CARTERA(P_PRODUCTE     IN ACCIO.TICKER%TYPE, 
                                             P_DATA         IN DATE,
                                             P_CLIENT       IN CLIENT.IDE_CLIENT%TYPE,
                                             P_UNITATS      IN CARTERA.UNITATS%TYPE,
                                             RSP            OUT VARCHAR2,
                                             ERR_DESC       OUT VARCHAR2) IS
  EXC_PARAM_OBLIGATORI EXCEPTION;
	EXC_FORANA EXCEPTION;
  EXC_CLIENT_BAIXA EXCEPTION;
	PRAGMA EXCEPTION_INIT(EXC_FORANA, -02291);
  V_PENTRADA VARCHAR2(1000);
  V_PSORTIDA VARCHAR2(100);
  V_CLIENT CLIENT.ACTIVATSN%TYPE;
  V_Q NUMBER;
BEGIN
  RSP:='OK - CARTERA alta ';
  ERR_DESC:=NULL;
  V_PSORTIDA:=RSP||' '||NVL(ERR_DESC,' ');
  V_PENTRADA:=P_PRODUCTE||','||P_DATA||','||P_CLIENT||','||P_UNITATS;
  -- ALTA a la taula AUDITORIA d'una nova crida a un procediment
  PROC_ALTA_AUDITORIA ('ALTA_CARTERA',V_PENTRADA,V_PSORTIDA,V_PSORTIDA);
	IF (P_PRODUCTE IS NULL OR P_CLIENT IS NULL OR P_UNITATS IS NULL) THEN
		RAISE EXC_PARAM_OBLIGATORI;
	END IF;
  -- comprovaci de si aquest client ja t en la cartera el producte i s un paquet d'accions actiu
  select activatsn into v_client
  from client
  where ide_client = p_client;
  if v_client='N' then
    raise exc_client_baixa;
  end if;
  SELECT COUNT(*) INTO V_Q
  FROM CARTERA
  WHERE client=P_CLIENT AND producte=P_PRODUCTE AND activasn='Y';
  IF V_Q=0 THEN
    -- Insereix una nova fila a la taula CARTERA
    INSERT INTO CARTERA (PRODUCTE,DATA,CLIENT,UNITATS,UNITATSDISPONIBLES,ACTIVASN)
    VALUES (P_PRODUCTE,P_DATA,P_CLIENT,P_UNITATS,P_UNITATS,'Y');
    -- l'actualitzaci de la quantitat de propietaris de l'accio es fa mitjanant un disparador
  ELSE -- el client ja tenia accions, per tant, cal incrementar la quantitat d'unitats de qu disposava
    UPDATE CARTERA
    SET data=P_DATA,
        UNITATS=unitats+p_UNITATS,
        unitatsdisponibles=unitatsdisponibles+p_unitats
    WHERE client=P_CLIENT AND producte=P_PRODUCTE AND activasn='Y';
  END IF;
	COMMIT;
  DBMS_OUTPUT.PUT_LINE(RSP);
EXCEPTION
    when no_data_found then
  		RSP:= 'ERROR 150231'; 
    	ERR_DESC:= 'El client '||p_client||' no existeix ';
   PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
    
		WHEN EXC_PARAM_OBLIGATORI THEN 
  		RSP:= 'ERROR 150232'; 
    	ERR_DESC:= 'Manquen indicar valors de camps obligatoris';
		-- Actualitzem la taula AUDITORIA amb el valor dels parmetres de sortida
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_FORANA THEN
      RSP := 'ERROR 150233';
  		ERR_DESC := 'Error amb la clau forana : ' ||SUBSTR(SQLERRM,INSTR(SQLERRM, '(')+1, (INSTR(SQLERRM,')')- (INSTR(SQLERRM,'(')+1)));
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_CLIENT_BAIXA THEN
      RSP := 'ERROR 150234';
  		ERR_DESC := 'No es pot donar d''alta un paquet d''accions en la cartera del client '||p_client||' perqu est donat de baixa';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN OTHERS THEN
  		RSP := 'ERROR 150235';
    	ERR_DESC := TO_CHAR(SQLCODE) || ' ' ||SQLERRM;
    	-- Actualitzem la taula AUDITORIA amb el valor del parmetre de sortida
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
END;
/
--====================================================================================
------------ MODIFICACI D'UN PAQUET D'ACCIONS DE LA CARTERA D'UN CLIENT -------------
--====================================================================================
-- Modificaci de les accions que posseeix un client en la seva cartera
-- Els camps que es podran modificar sn: DATA, UNITATS i UNITATSDISPONIBLES
-- Els parmetres que el seu nom s'inicia amb la partcula P_MOD_ noms poden pendre els valors: 0 o 1
-- 1 vol dir que el segent parmetre es vol modificar
-- 0 vol dir que el segent parmetre no es vol modificar, per aix habitualment el segent parmetre ser NULL
set define off;
CREATE OR REPLACE PROCEDURE PROC_MODIF_CARTERA (P_CLIENT IN CARTERA.CLIENT%TYPE ,P_PRODUCTE IN CARTERA.PRODUCTE%TYPE,
      P_MOD_data IN NUMBER,P_data     IN date, 
      P_MOD_unitats IN NUMBER,P_unitats     IN cartera.unitats%type,
      P_MOD_unitatsDisponibles IN NUMBER,P_unitatsdisponibles IN cartera.unitatsdisponibles%type,
                                            RSP       OUT VARCHAR2,
                                            ERR_DESC  OUT VARCHAR2) AS
  V_PENTRADA VARCHAR2(1000);
  V_PSORTIDA VARCHAR2(100);
  EXC_IDExCERCAR EXCEPTION;
	EXC_PARAM_OBLIGATORI EXCEPTION;
	EXC_FORANA EXCEPTION;
  exc_no_modif EXCEPTION;
	PRAGMA EXCEPTION_INIT(EXC_FORANA, -2291);
  R_CARTERA CARTERA%ROWTYPE;
BEGIN 
  RSP:='OK - CARTERA modificaci';
  ERR_DESC:=NULL;
  V_PSORTIDA:=RSP||' '||NVL(ERR_DESC,' ');
  V_PENTRADA:=P_CLIENT||','||P_PRODUCTE||','||P_MOD_DATA||'-'||P_DATA||','||P_MOD_UNITATS||'-'||P_UNITATS||','||P_MOD_UNITATSDISPONIBLES||'-'||P_UNITATSDISPONIBLES;
  PROC_ALTA_AUDITORIA ('MODIFICAR_CARTERA',V_PENTRADA,V_PSORTIDA,V_PSORTIDA);
  IF (P_CLIENT IS NULL OR P_PRODUCTE IS NULL) THEN
		RAISE EXC_IDExCERCAR;
	END IF;
  IF ((P_MOD_DATA = 1 AND P_data IS NULL) OR (P_MOD_UNITATS = 1 AND P_UNITATS IS NULL) OR (P_MOD_UNITATSDISPONIBLES = 1 AND P_UNITATSDISPONIBLES IS NULL)) THEN
    RAISE EXC_PARAM_OBLIGATORI;
  END IF;
  if (p_mod_data = 0 and p_mod_unitats = 0 and p_mod_unitatsdisponibles = 0) then
    raise exc_no_modif;
  end if;
    SELECT * INTO R_CARTERA
    FROM CARTERA
	  WHERE CLIENT=P_CLIENT AND PRODUCTE=P_PRODUCTE AND activasn='Y';
    UPDATE CARTERA 
		SET DATA = DECODE(P_MOD_DATA,NULL,R_CARTERA.DATA,0,R_CARTERA.DATA,P_DATA),
        UNITATS = DECODE(P_MOD_UNITATS, NULL, R_CARTERA.UNITATS, 0, R_CARTERA.UNITATS, P_UNITATS),
        UNITATSDISPONIBLES = DECODE(P_MOD_UNITATSDISPONIBLES,NULL,R_CARTERA.UNITATSDISPONIBLES,0,R_CARTERA.UNITATSDISPONIBLES,P_UNITATSDISPONIBLES)
		WHERE CLIENT = R_CARTERA.CLIENT AND PRODUCTE = R_CARTERA.PRODUCTE AND activasn = 'Y';
    COMMIT;
	DBMS_OUTPUT.PUT_LINE(RSP);
EXCEPTION
	WHEN EXC_IDExCERCAR THEN
		RSP:= 'ERROR 150236';
		ERR_DESC:= 'Cal indicar el ticker de l''acci i l''identificador del client';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_PARAM_OBLIGATORI THEN
		RSP := 'ERROR 150237';
		ERR_DESC := 'Parmetres obligatoris no informats';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN NO_DATA_FOUND THEN 
		RSP := 'ERROR 150238';
		ERR_DESC := 'El client '||p_client||' no t aquestes accions '||p_producte||' en cartera';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_NO_MODIF THEN 
		RSP := 'ERROR 150239';
		ERR_DESC := 'No s''ha indicat cap dada per ser modificada!';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN OTHERS THEN
		RSP := 'ERROR 150240';
		ERR_DESC := 'ERROR '||SQLCODE||' '||SQLERRM;
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
END;
/
--====================================================================================
---------------------- BAIXA D'UN PAQUET D'ACCIONS D'UN CLIENT -----------------------
--====================================================================================
-- La baixa d'un paquet d'accions que posseeix un client
-- La baixa no es far fsica, sin lgica, s a dir es posar l'atribut activatSN a 'N',
CREATE OR REPLACE PROCEDURE PROC_BAIXA_CARTERA (P_PRODUCTE     IN CARTERA.PRODUCTE%TYPE,
                                               P_CLIENT     IN CARTERA.CLIENT%TYPE, 
                                               RSP OUT VARCHAR2,
                                               ERR_DESC OUT VARCHAR2) AS
  V_PSORTIDA VARCHAR2(100);
  V_PENTRADA VARCHAR2(1000);
	EXC_MANDATORY_IN EXCEPTION;
	EXC_CARTERA_JA_BAIXA EXCEPTION;
  EXC_NO_TROBAT EXCEPTION;
  V_YES NUMBER;
  V_NO NUMBER;
BEGIN
  RSP:='OK - CARTERA baixa';
  ERR_DESC:=NULL;
  V_PSORTIDA:=RSP||' '||NVL(ERR_DESC,' ');
  V_PENTRADA:=P_PRODUCTE||'-'||P_CLIENT;
  PROC_ALTA_AUDITORIA ('BAIXA_CARTERA',V_PENTRADA,V_PSORTIDA,V_PSORTIDA);
  IF (P_PRODUCTE IS NULL OR P_CLIENT IS NULL) THEN
		RAISE EXC_MANDATORY_IN;
	END IF;
  SELECT COUNT(*) INTO V_YES
  FROM CARTERA
  WHERE CLIENT = P_CLIENT AND PRODUCTE = P_PRODUCTE AND activasn='Y';
  SELECT COUNT(*) INTO V_NO
  FROM CARTERA
  WHERE CLIENT = P_CLIENT AND PRODUCTE = P_PRODUCTE AND activasn='N';
  IF V_YES=0 AND V_NO=0 THEN
      RAISE EXC_NO_TROBAT;
  END IF; 
  IF V_YES=0 AND V_NO>0 THEN
      RAISE EXC_CARTERA_JA_BAIXA;
  END IF;
  -- Modificaci del PAQUET D'accions posant ACTIVATSN a N
  UPDATE CARTERA
	SET  ACTIVASN='N'
	WHERE CLIENT = p_CLIENT AND PRODUCTE = P_PRODUCTE AND ACTIVASN = 'Y';
  -- L'actualitza de la quantitat de propietaris de l'accio es fa grcies a un trigger
  DBMS_OUTPUT.PUT_LINE(RSP);
EXCEPTION
	WHEN EXC_MANDATORY_IN THEN
		RSP := 'ERROR 150241';
		ERR_DESC := 'L''IDE del client i el TICKER de l''acci sn obligatoris';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN exc_NO_trobat THEN
		RSP := 'ERROR 150242';
		ERR_DESC := 'No s''ha trobat el client '||p_client||' amb accions '||p_producte||' en cartera';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_Cartera_JA_BAIXA THEN
		RSP := 'ERROR 150243';
		ERR_DESC := 'El client '||p_client||' ja t el paquet d''accions '||p_producte||' donades de baixa';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN OTHERS THEN
		RSP := 'ERROR 150244';
		ERR_DESC:='ERROR '||SQLCODE||' '||SQLERRM;
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
END;
/