--====================================================================================
---------------------- ALTA D'UN CLIENT ----------------------------------------------
--====================================================================================
-- L'identificador del client s'assigna automticament grcies a una seqncia, per tant, 
-- no es demanar mai, la qual cosa estalvia el control de certes excepcions com:
-- identificadors amb valors repetits o no indicats per oblits.
--set define off;
CREATE OR REPLACE PROCEDURE PROC_ALTA_CLIENT(P_NIF     IN CLIENT.NIF%TYPE, 
                                            P_NOM     IN CLIENT.NOM%TYPE,
                                            P_COGNOMS IN CLIENT.COGNOMS%TYPE,
                                            P_DATANAIX IN CLIENT.DATANAIX%TYPE,
                                            P_DATAALTA IN CLIENT.DATAALTA%TYPE,
                                            P_ADRESA  IN CLIENT.ADRESA%TYPE,
                                            P_CP      IN CLIENT.CP%TYPE,
                                            P_TELEFON IN CLIENT.TELEFON%TYPE,
                                            P_EMAIL   IN CLIENT.EMAIL%TYPE,
                                            P_CIUTAT  IN CLIENT.CIUTAT%TYPE,
                                            P_PAIS    IN CLIENT.PAIS%TYPE,
                                            RSP       OUT VARCHAR2,
                                            ERR_DESC  OUT VARCHAR2) AS
  EXC_PARAM_OBLIGATORI EXCEPTION;
	EXC_FORANA EXCEPTION;
  EXC_CLAU_ALTERNATIVA EXCEPTION;
	PRAGMA EXCEPTION_INIT(EXC_FORANA, -02291);
  PRAGMA EXCEPTION_INIT(EXC_CLAU_ALTERNATIVA, -00001);
	V_DATA_BAIXA DATE;
  V_PENTRADA auditoria.pentrada%type;
  V_PSORTIDA auditoria.psortida%type;
BEGIN
  RSP:='OK - CLIENT alta ';
  ERR_DESC:=NULL;
  V_PSORTIDA:=RSP||' '||NVL(ERR_DESC,' ');
  V_PENTRADA:=P_NIF||' '||P_NOM||' '||P_COGNOMS||' '||P_DATANAIX||' '||P_DATAALTA||' '||P_ADRESA||' '||P_CP||' '||P_TELEFON||' '||P_EMAIL||' '||P_CIUTAT||' '||P_PAIS;
  -- ALTA a la taula AUDITORIA d'una nova crida a un procediment
  PROC_ALTA_AUDITORIA ('ALTA_CLIENT',V_PENTRADA,V_PSORTIDA,RSP||' '||NVL(ERR_DESC,' '));
	IF (P_NIF IS NULL OR P_NOM IS NULL OR P_COGNOMS IS NULL OR P_DATANAIX IS NULL OR P_DATAALTA IS NULL OR P_ADRESA IS NULL OR P_CP IS NULL OR P_TELEFON IS NULL OR P_EMAIL IS NULL OR P_CIUTAT IS NULL OR P_PAIS IS NULL) THEN
		RAISE EXC_PARAM_OBLIGATORI;
	END IF;
	-- Insereix una nova fila a la taula CLIENT
	INSERT INTO CLIENT (IDE_CLIENT,nif,nom,cognoms,datanaix,dataalta,adresa,cp,telefon,email,ciutat,pais)
  VALUES (null,P_NIF,P_NOM,P_COGNOMS,P_DATANAIX,P_DATAALTA,P_ADRESA,P_CP,P_TELEFON,P_EMAIL,P_CIUTAT,P_PAIS);
	COMMIT;
  DBMS_OUTPUT.PUT_LINE(RSP);
EXCEPTION
		WHEN EXC_PARAM_OBLIGATORI THEN
  		RSP:= 'ERROR 150200'; 
    	ERR_DESC:= 'Manquen indicar valors de camps obligatoris';
		  -- Actualitzem la taula AUDITORIA amb el valor dels parmetres de sortida
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_FORANA THEN
      RSP := 'ERROR 150201';
  		ERR_DESC := 'Error '||SQLCODE||' amb la clau forana : ' ||SUBSTR(SQLERRM,INSTR(SQLERRM, '(')+1, (INSTR(SQLERRM,')')- (INSTR(SQLERRM,'(')+1)));
  		PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN EXC_CLAU_ALTERNATIVA THEN
      RSP := 'ERROR 150202';
  		ERR_DESC := 'El NIF d''un client no es pot repetir';
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
      DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN OTHERS THEN
  		RSP := 'ERROR 150203';
    	ERR_DESC := TO_CHAR(SQLCODE) || ' ' ||SQLERRM;
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
      DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
END;
/
--SHOW ERRORS;
--====================================================================================
---------------------- MODIFICACI D'UN CLIENT ---------------------------------------
--====================================================================================
-- La modificaci d'un CLIENT podr fer-se pel seu IDE_CLIENT o b pel seu NIF. 
-- Tots els camps es podran modificar menys: IDE_CLIENT, DATAALTA,ACTIVATSN,VALORACTUALCARTERA
-- Els parmetres que el seu nom s'inicia amb la partcula P_MOD_ noms poden pendre els valors: 0 o 1
-- 1 vol dir que el segent parmetre es vol modificar
-- 0 vol dir que el segent parmetre no es vol modificar, per aix habitualment el segent parmetre ser NULL
set define off;
CREATE OR REPLACE PROCEDURE PROC_MODIF_CLIENT (P_IDE     IN CLIENT.IDE_CLIENT%TYPE,
      P_MOD_NIF IN NUMBER,P_NIF     IN CLIENT.NIF%TYPE, 
      P_MOD_NOM IN NUMBER,P_NOM     IN CLIENT.NOM%TYPE,
      P_MOD_COGNOMS IN NUMBER,P_COGNOMS IN CLIENT.COGNOMS%TYPE,
      P_MOD_NAIX IN NUMBER,P_DATANAIX IN CLIENT.DATANAIX%TYPE,
      P_MOD_ADRE IN NUMBER,P_ADRESA  IN CLIENT.ADRESA%TYPE,
      P_MOD_CP IN NUMBER,P_CP      IN CLIENT.CP%TYPE,
      P_MOD_TEL IN NUMBER,P_TELEFON IN CLIENT.TELEFON%TYPE,
      P_MOD_MAIL IN NUMBER,P_EMAIL   IN CLIENT.EMAIL%TYPE,
      P_MOD_CIUTAT IN NUMBER,P_CIUTAT  IN CLIENT.CIUTAT%TYPE,
      P_MOD_PAIS IN NUMBER,P_PAIS    IN CLIENT.PAIS%TYPE,
                                            RSP       OUT VARCHAR2,
                                            ERR_DESC  OUT VARCHAR2) AS
	V_SEQ_LOG NUMBER;
  V_PENTRADA auditoria.pentrada%type;
  V_PSORTIDA auditoria.psortida%type;
  EXC_IDExCERCAR EXCEPTION;
	EXC_PARAM_OBLIGATORI EXCEPTION;
	EXC_FORANA EXCEPTION;
  EXC_NO_MODIF EXCEPTION;
	PRAGMA EXCEPTION_INIT(EXC_FORANA, -2291);
  R_CLIENT CLIENT%ROWTYPE;
BEGIN
  RSP:='OK - CLIENT modificaci';
  ERR_DESC:=NULL;
  V_PSORTIDA:=RSP||' '||NVL(ERR_DESC,' ');
  V_PENTRADA:=P_IDE||' '||P_MOD_NIF||' '||P_NIF||' '||P_MOD_NOM||' '||P_NOM||' '||P_MOD_COGNOMS||' '||P_COGNOMS||' '||P_MOD_NAIX||' '||P_DATANAIX||' '||P_MOD_ADRE||' '||P_ADRESA||' '||P_MOD_CP||' '||P_CP||' '||P_MOD_TEL||' '||P_TELEFON||' '||P_MOD_MAIL||' '||P_EMAIL||' '||P_MOD_CIUTAT||' '||P_CIUTAT||' '||P_MOD_PAIS||' '||P_PAIS;
  PROC_ALTA_AUDITORIA ('MODIFICAR_CLIENT',V_PENTRADA,V_PSORTIDA,V_PSORTIDA);
	IF (P_IDE IS NULL AND P_NIF IS NULL) THEN
		RAISE EXC_IDExCERCAR;
	END IF;
  IF ( 
    (P_MOD_NIF = 1 AND P_NIF IS NULL) OR
    (P_MOD_NOM = 1 AND P_NOM IS NULL) OR
    (P_MOD_COGNOMS = 1 AND P_COGNOMS IS NULL) OR
    (P_MOD_NAIX = 1 AND P_DATANAIX IS NULL) OR
    (P_MOD_ADRE = 1 AND P_ADRESA IS NULL) OR
    (P_MOD_CP = 1 AND P_CP IS NULL) OR
    (P_MOD_TEL = 1 AND P_TELEFON IS NULL) OR
    (P_MOD_MAIL = 1 AND P_EMAIL IS NULL) OR
    (P_MOD_CIUTAT = 1 AND P_CIUTAT IS NULL) OR
    (P_MOD_PAIS = 1 AND P_PAIS IS NULL)
    ) THEN
    RAISE EXC_PARAM_OBLIGATORI;
  END IF;
  IF (P_MOD_NIF=0 AND P_MOD_NOM=0 AND P_MOD_COGNOMS=0 AND P_MOD_NAIX=0 AND P_MOD_ADRE=0 AND P_MOD_CP=0 AND P_MOD_TEL=0 AND P_MOD_MAIL=0 AND P_MOD_CIUTAT=0 AND P_MOD_PAIS=0) THEN
    RAISE EXC_NO_MODIF;
  END IF;
  IF (P_IDE IS NOT NULL) THEN
    SELECT * INTO R_CLIENT
    FROM CLIENT
	  WHERE IDE_CLIENT=P_IDE;
  ELSE
    SELECT * INTO R_CLIENT
    FROM CLIENT
	  WHERE NIF LIKE P_NIF;
  END IF;  
    UPDATE CLIENT 
		SET NIF = DECODE(P_MOD_NIF,NULL,R_CLIENT.NIF,0,R_CLIENT.NIF,P_NIF),
        NOM = DECODE(P_MOD_NOM, NULL, R_CLIENT.NOM,  0, R_CLIENT.NOM, P_NOM),
        COGNOMS = DECODE(P_MOD_COGNOMS, NULL, R_CLIENT.COGNOMS, 0, R_CLIENT.COGNOMS, P_COGNOMS),
        DATANAIX =  DECODE(P_MOD_NAIX, NULL, R_CLIENT.DATANAIX,0, R_CLIENT.DATANAIX, P_DATANAIX),
        ADRESA = DECODE(P_MOD_ADRE,NULL,R_CLIENT.ADRESA ,0,R_CLIENT.ADRESA ,P_ADRESA ),
        CP = DECODE(P_MOD_CP,NULL,R_CLIENT.CP ,0,R_CLIENT.CP ,P_CP),
        TELEFON = DECODE(P_MOD_TEL,NULL,R_CLIENT.TELEFON ,0,R_CLIENT.TELEFON ,P_TELEFON ),
        EMAIL = DECODE(P_MOD_MAIL, NULL, R_CLIENT.EMAIL, 0, R_CLIENT.EMAIL, P_EMAIL),
        CIUTAT =  DECODE(P_MOD_CIUTAT, NULL, R_CLIENT.CIUTAT, 0, R_CLIENT.CIUTAT, P_CIUTAT),
        PAIS = DECODE(P_MOD_PAIS, NULL, R_CLIENT.PAIS, 0, R_CLIENT.PAIS, P_PAIS)
		WHERE IDE_CLIENT = R_CLIENT.IDE_CLIENT;
  COMMIT;
	DBMS_OUTPUT.PUT_LINE(RSP);
EXCEPTION
  WHEN EXC_NO_MODIF THEN
		RSP:= 'ERROR 150204';
		ERR_DESC:= 'No s''ha indicat cap camp a modificar!';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_IDExCERCAR THEN
		RSP:= 'ERROR 150205';
		ERR_DESC:= 'Identificador del client i/o NIF no indicats i sn obligatoris';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_PARAM_OBLIGATORI THEN
		RSP := 'ERROR 150206';
		ERR_DESC := 'Parmetres obligatoris no informats';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN NO_DATA_FOUND THEN 
		RSP := 'ERROR 150207';
		ERR_DESC := 'L''ide o nif indicat no Identifiquen a cap client';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_FORANA THEN 
		RSP := 'ERROR 150208';
		ERR_DESC := 'Error '||SQLCODE||' amb la clau forana : ' ||SUBSTR(SQLERRM,INSTR(SQLERRM, '(')+1, (INSTR(SQLERRM,')')- (INSTR(SQLERRM,'(')+1)));
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN OTHERS THEN
		RSP := 'ERROR 150208';
		ERR_DESC := 'ERROR '||SQLCODE||' '||SQLERRM;
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
END;
/
--SHOW ERRORS;
--====================================================================================
---------------------- BAIXA D'UN CLIENT ---------------------------------------
--====================================================================================
-- La baixa d'un CLIENT podr fer-se pel seu IDE o b pel seu NIF. 
-- La baixa no es far fsica, sin lgica, s a dir es posar l'atribut activatSN a 'N',
-- Aquest procediment tamb s'encarregar de donar de baixa les seves ordres de compra venda i tots els productes de la seva cartera
CREATE OR REPLACE PROCEDURE PROC_BAIXA_CLIENT (P_IDE     IN CLIENT.IDE_CLIENT%TYPE,
                                               P_NIF     IN CLIENT.NIF%TYPE, 
                                               RSP OUT VARCHAR2,
                                               ERR_DESC OUT VARCHAR2) AS
  type reg_client is record
  (
  ide client.ide_client%type,
  activat client.activatsn%type
  );
	V_RSP VARCHAR2(20);
  V_ERR_DESC VARCHAR2(400);
	V_SEQ_LOG NUMBER;
  V_PSORTIDA VARCHAR2(100);
  V_PENTRADA VARCHAR2(1000);
	EXC_MANDATORY_IN EXCEPTION;
	EXC_CLIENT_JA_BAIXA EXCEPTION;
	R_CLIENT reg_client;
  cursor c_ordres(cli client.ide_client%type) is select ide_ordre from ordre where client =cli;
  cursor c_paquets(cli client.ide_client%type) is select producte from cartera where client=cli;
BEGIN
  RSP:='OK - CLIENT baixa ';
  ERR_DESC:=NULL;
  V_PSORTIDA:=RSP||' '||NVL(ERR_DESC,' ');
  V_PENTRADA:=P_IDE||' '||P_NIF;
  PROC_ALTA_AUDITORIA ('BAIXA_CLIENT',V_PENTRADA,V_PSORTIDA,V_PSORTIDA);
	IF (P_IDE IS NULL AND P_NIF IS NULL) THEN
		RAISE EXC_MANDATORY_IN;
	END IF;
  IF (P_IDE IS NOT NULL) THEN
    SELECT ide_client,activatsn INTO R_CLIENT
    FROM CLIENT
    WHERE IDE_CLIENT = P_IDE;
	ELSE
    SELECT ide_client,activatsn INTO R_CLIENT
    FROM CLIENT
    WHERE NIF = P_NIF;
	END IF;
	IF (R_CLIENT.ACTIVAT LIKE 'N') THEN
		RAISE EXC_CLIENT_JA_BAIXA;
	END IF;
  -- Modificaci del client posant ACTIVATSN a N
  UPDATE CLIENT 
	SET  ACTIVATSN='N'
	WHERE IDE_CLIENT = R_CLIENT.IDE; 
  for r_c in c_ordres(r_client.ide) loop
    PROC_BAIXA_ORDRE(r_c.ide_ordre ,r_client.ide ,V_RSP,V_ERR_DESC);
  end loop;
  for r_c in c_paquets(r_client.ide) loop 
    PROC_BAIXA_CARTERA(r_c.producte, r_client.ide,v_RSP,v_ERR_DESC); 
  end loop;
  DBMS_OUTPUT.PUT_LINE(RSP);
EXCEPTION
	WHEN EXC_MANDATORY_IN THEN
		RSP := 'ERROR 150209';
		ERR_DESC := 'L''IDE del client i/o el NIF sn obligatoris';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN NO_DATA_FOUND THEN
		RSP := 'ERROR 150210';
		ERR_DESC := 'L''IDE indicat o el NIF no corresponen a cap client';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN EXC_CLIENT_JA_BAIXA THEN
		RSP := 'ERROR 150211';
		ERR_DESC := 'El client ja est donat de baixa';
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
	WHEN OTHERS THEN
		RSP := 'ERROR 150212';
		ERR_DESC:='ERROR '||SQLCODE||' '||SQLERRM;
    PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
END;
/