set define off;
--=================================================================================================
--             1.	Composici de la cartera daccions dun client
--=================================================================================================
CREATE OR REPLACE PROCEDURE PROC_1 (  P_DATA      IN      DATE,
                                      P_IDE_CLIENT IN      NUMBER,
                                            RSP       OUT VARCHAR2,
                                            ERR_DESC  OUT VARCHAR2) IS
  V_ACTIVA CHAR(1):='Z';
  V_Q NUMBER(38,6):=NULL;
  V_PENTRADA VARCHAR2(1000);
  V_PSORTIDA VARCHAR2(100);
  EXC_CLIENT_BAIXA EXCEPTION; --aquest consulta no t sentit, donat que s un client que ha estat donat de baixa
  EXC_CARTERA_BUIDA EXCEPTION; --Si el client t la cartera daccions buida
  EXC_DATA_ERROR EXCEPTION;
  cursor c_1 (d actualitzar.data%type, cli cartera.client%type) is  -- cursor parametritzat
          select cartera.producte "ACCIO",SUBSTR(accio.nom,1,30) "NOM",cartera.Unitats unitats,actualitzar.preutancament "Preu unitat actual",sum(cartera.Unitats*actualitzar.preutancament) "Import total"
        from cartera JOIN accio on (cartera.producte = accio.ticker)
                     JOIN actualitzar on (accio.ticker = actualitzar.producte)
        where   actualitzar.data = d and cartera.client = cli AND CARTERA.ACTIVASN='Y'
        group by cartera.producte,accio.nom,cartera.Unitats,actualitzar.preutancament
        ORDER BY 1;
BEGIN
    RSP:='OK'; -- PER DEFECTE OK
    V_PSORTIDA:=RSP;
    V_PENTRADA:=P_DATA||' - '||P_IDE_CLIENT;
   -- ALTA a la taula AUDITORIA d'una nova crida a un procediment
   PROC_ALTA_AUDITORIA ('CONSULTA 1',V_PENTRADA,V_PSORTIDA,RSP);
   SELECT ACTIVATSN INTO V_ACTIVA
   FROM CLIENT
   WHERE IDE_CLIENT = P_IDE_CLIENT;
   IF V_ACTIVA LIKE 'N' THEN
      RAISE EXC_CLIENT_BAIXA; --aquest consulta no t sentit, donat que el client ha estat donat de baixa
   END IF;
   IF P_DATA>SYSDATE OR P_DATA<DATE '2015-01-01' THEN
      RAISE EXC_DATA_ERROR;
   END IF;
   V_Q:=func_VALOR_1_CARTERA (P_DATA,P_IDE_CLIENT,RSP,ERR_DESC);
   IF V_Q=0 THEN
      RAISE EXC_CARTERA_BUIDA; --Si el client t la cartera daccions buida
   end if;
   -- recorregut del cursor (obertura i tancaments auotmtics)
   V_Q:=0;
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------------------------------------------------------------');
      DBMS_OUTPUT.PUT_LINE('Composici de la cartera daccions del client '||P_IDE_CLIENT||' data '||p_data);
      DBMS_OUTPUT.PUT_LINE('ACCIO   - NOM                                 - unitats - Preu unitat actual       - Import total');
      DBMS_OUTPUT.PUT_LINE('-------------------------------------------------------------------------------------------------');
   for ordre in c_1(p_data,p_ide_client) loop
      IF ORDRE.UNITATS!=0 THEN
          DBMS_OUTPUT.PUT_LINE(RPAD(ORDRE."ACCIO",7)||' - '||RPAD(ORDRE."NOM",35)||' - '||LPAD(ORDRE.unitats,7)||' - '||LPAD(TO_CHAR(ORDRE."Preu unitat actual",'9G999D999999'),18)||' - '||LPAD(TO_CHAR(ORDRE."Import total",'99G999D999999'),18));
      END IF;          
      V_Q:=V_Q+1;
   end loop;
   IF V_Q=0 THEN
      DBMS_OUTPUT.PUT_LINE('No hi ha dades a mostrar');
   END IF;
EXCEPTION  -- SORTIDA SI S'HA PRODUIT UNA EXCEPCI
    WHEN NO_DATA_FOUND THEN --el client indicat no existeix a dins la BD
  		RSP:= 'ERROR 150250'; 
    	ERR_DESC:= 'L''Identificador del client '||P_IDE_CLIENT||' no s''ha trobat dins la Base de Dades';
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
    WHEN EXC_DATA_ERROR THEN
      RSP:= 'ERROR 150251';
      ERR_DESC:= 'La data indicada no es correcte per les dades que gestiona la Base de Dades';
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
    WHEN EXC_CLIENT_BAIXA THEN --aquest consulta no t sentit, donat que s un client que ha estat donat de baixa
      RSP:= 'ERROR 150252';
      ERR_DESC:= 'El client '||P_IDE_CLIENT||' ha estat donat de baixa';
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
    WHEN EXC_CARTERA_BUIDA THEN --Si el client t la cartera daccions buida
      RSP:= 'ERROR 150253';
      ERR_DESC:= 'El client '||P_IDE_CLIENT||' t la seva cartera d''accions buida';
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
    WHEN OTHERS THEN 
      RSP:= 'ERROR 150254'; 
      ERR_DESC:= SQLERRM;
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
END;
/
--=================================================================================================
--             2.	Resum dOperacions Anuals
--=================================================================================================
CREATE OR REPLACE PROCEDURE PROC_2(P_ANY IN char, RSP OUT VARCHAR2, ERR_DESC  OUT VARCHAR2) iS
type r_dades is record
(
  qOrdresC number(4,0),
  qOrdresCexe number(4,0),
  sOrdresCexe number(38,6),
  avgCexe number(38,6),
  qOrdresV number(4,0),
  qOrdresVexe number(4,0),
  sOrdresVexe number(38,6),
  avgVexe number(38,6),
  qOrdresCcancel number(4,0),
  qOrdresVcancel number(4,0)
);
  v_dades r_dades;
  CURSOR C_CLIENTS IS SELECT IDE_CLIENT,NOM,COGNOMS FROM CLIENT WHERE ACTIVATSN='Y';
  EXC_ANY_ERROR EXCEPTION;
  EXC_NO_CLIENTS EXCEPTION;
  EXC_NO_ORDRES EXCEPTION;
  V_PENTRADA AUDITORIA.PENTRADA%TYPE;
  V_PSORTIDA AUDITORIA.PSORTIDA%TYPE;
  V_Q NUMBER;
  V_CADENA VARCHAR2(250);
BEGIN        
  RSP:='OK';
  V_PSORTIDA:=RSP;
  V_PENTRADA:=P_ANY;
  -- ALTA a la taula AUDITORIA d'una nova crida a un procediment
  PROC_ALTA_AUDITORIA ('CONSULTA 2',V_PENTRADA,V_PSORTIDA,RSP);
  IF (P_ANY IS NULL OR P_ANY<'2015' OR P_ANY>'3000') THEN
    RAISE EXC_ANY_ERROR;
  END IF;
  SELECT COUNT(*) INTO V_Q
  FROM CLIENT WHERE ACTIVATSN='Y';
  IF V_Q = 0 THEN
    RAISE EXC_NO_CLIENTS;
  END IF;
  SELECT COUNT(*) INTO V_Q
  FROM ORDRE WHERE ACTIVASN='Y' and to_char(ordre.dataentrada,'yyyy') like p_any;
  IF V_Q = 0 THEN
    RAISE EXC_NO_ORDRES;
  END IF;
DBMS_OUTPUT.PUT_LINE('----------------------------------------------------------------------------------------------------------------------------------------------------');  
DBMS_OUTPUT.PUT_LINE('                                   Llistat de tots els clients que han realitzat operacions durant l''any '||p_any);
DBMS_OUTPUT.PUT_LINE('----------------------------------------------------------------------------------------------------------------------------------------------------');
DBMS_OUTPUT.PUT_LINE('CLIENT                                      sobre les compres                                                sobre les Vendes ');
DBMS_OUTPUT.PUT_LINE('----------------------------------------------------------------------------------------------------------------------------------------------------');
DBMS_OUTPUT.PUT_LINE('                             total - executades - import - import mig - cancellades    --   total - executades - import - import mig - cancellades');
DBMS_OUTPUT.PUT_LINE('----------------------------------------------------------------------------------------------------------------------------------------------------');  
FOR R_C IN C_CLIENTS LOOP
        SELECT COUNT(*) INTO V_DADES.qOrdresC
        FROM CLIENT JOIN ORDRE ON (CLIENT.IDE_CLIENT=ORDRE.CLIENT)
        WHERE ORDRE.TIPUS LIKE 'COMPRA' AND TO_CHAR(ORDRE.DATAENTRADA,'YYYY')=P_ANY AND CLIENT.IDE_CLIENT=R_C.IDE_CLIENT;
      IF V_DADES.QORDRESC != 0 THEN
        SELECT COUNT(*),SUM(ORDRE.PREU*ORDRE.UNITATS) ,SUM(ORDRE.PREU*ORDRE.UNITATS)/COUNT(*) into V_DADES.qOrdresCexe,V_DADES.sOrdresCexe,V_DADES.avgCexe
        FROM CLIENT JOIN ORDRE ON (CLIENT.IDE_CLIENT=ORDRE.CLIENT)
        WHERE ORDRE.TIPUS LIKE 'COMPRA' AND TO_CHAR(ORDRE.DATAENTRADA,'YYYY')=P_ANY AND ORDRE.ESTAT LIKE 'executada'
        AND CLIENT.IDE_CLIENT=R_C.IDE_CLIENT;
    --
        SELECT COUNT(*) INTO V_DADES.qOrdresCcancel
        FROM CLIENT JOIN ORDRE ON (CLIENT.IDE_CLIENT=ORDRE.CLIENT)
        WHERE ORDRE.TIPUS LIKE 'COMPRA' AND TO_CHAR(ORDRE.DATAENTRADA,'YYYY')=P_ANY AND ORDRE.ESTAT LIKE 'cancelada'
        AND CLIENT.IDE_CLIENT=R_C.IDE_CLIENT;
      else
        v_dades.qOrdresCcancel:=0;
        V_DADES.QORDREScEXE:=0;
        V_DADES.sOrdrescexe:=null;
        V_DADES.avgcexe:=null;
      END IF;
        SELECT COUNT(*) into   V_DADES.qOrdresV
        FROM CLIENT JOIN ORDRE ON (CLIENT.IDE_CLIENT=ORDRE.CLIENT)
        WHERE ORDRE.TIPUS LIKE 'VENDA' AND TO_CHAR(ORDRE.DATAENTRADA,'YYYY')=P_ANY
        AND CLIENT.IDE_CLIENT=R_C.IDE_CLIENT;
      IF V_DADES.QORDRESV !=0 THEN
        SELECT COUNT(*),SUM(ORDRE.PREU*ORDRE.UNITATS) ,SUM(ORDRE.PREU*ORDRE.UNITATS)/COUNT(*) INTO   V_DADES.qOrdresVexe,V_DADES.sOrdresVexe,V_DADES.avgVexe
        FROM CLIENT JOIN ORDRE ON (CLIENT.IDE_CLIENT=ORDRE.CLIENT)
        WHERE ORDRE.TIPUS LIKE 'VENDA' AND TO_CHAR(ORDRE.DATAENTRADA,'YYYY')=P_ANY AND ORDRE.ESTAT LIKE 'executada'
        AND CLIENT.IDE_CLIENT=R_C.IDE_CLIENT;
    -- 
        SELECT COUNT(*) INTO V_DADES.qOrdresVcancel
        FROM CLIENT JOIN ORDRE ON (CLIENT.IDE_CLIENT=ORDRE.CLIENT)
        WHERE ORDRE.TIPUS LIKE 'VENDA' AND TO_CHAR(ORDRE.DATAENTRADA,'YYYY')=P_ANY AND ORDRE.ESTAT LIKE 'cancelada'
        AND CLIENT.IDE_CLIENT=R_C.IDE_CLIENT;
    
      ELSE
        V_DADES.qOrdresVcancel:=0;
        V_DADES.QORDRESVEXE:=0;
        V_DADES.sOrdresVexe:=null;
        V_DADES.avgVexe:=null;
      END IF; 
      if not (v_dades.qORdresC=0 and v_dades.qOrdresV=0) then -- si el client actual ha realitzat alguna operaci duran l'any indicat
          V_CADENA:=RPAD(R_C.NOM||' '||R_C.COGNOMS,25)||' '||LPAD(V_DADES.qOrdresC,5)||' '||LPAD(V_DADES.qOrdresCexe,13)||' ';
          --COMPRES
          if (v_dades.sordresCexe is null) then
            V_CADENA:=V_CADENA||LPAD(' ',12)||' '||LPAD(' ',10)||' ';
          ELSE
            V_CADENA:=V_CADENA||LPAD(TO_CHAR(v_dades.sordresCexe,'999G999D99'),12)||' '||LPAD(TO_CHAR(V_DADES.avgCexe,'999G999D99'),10)||' ';
          END IF;
            V_CADENA:=V_CADENA||lpad(V_DADES.qOrdresCcancel,10)||' '||LPAD(V_DADES.qOrdresV,15)||' '||LPAD(V_DADES.qOrdresVexe,13)||' ';
          -- VENDES
          IF (V_DADES.SORDRESVEXE IS NULL) THEN
            V_CADENA:=V_CADENA||LPAD(' ',10)||' '||LPAD(' ',10)||' '||lpad(V_DADES.qOrdresVcancel,10);      
          ELSE
            V_CADENA:=V_CADENA||LPAD(TO_CHAR(v_dades.sordresVexe,'999G999D99'),10)||' '||LPAD(TO_CHAR(v_dades.AVGVexe,'999G999D99'),10)||' '||lpad(V_DADES.qOrdresVcancel,10);
          END IF;
          -- MOSTRAR INFORMACI PER PANTALLA
          DBMS_OUTPUT.PUT_LINE(V_CADENA);
      end if;
  END LOOP;                                                                                                                                                                                                                                        
EXCEPTION
  WHEN EXC_ANY_ERROR THEN
  		RSP:= 'ERROR 150255'; 
    	ERR_DESC:= 'L''any indicat no s valid per la informaci que hi ha dins la BD';
		-- Actualitzem la taula AUDITORIA amb el valor dels parmetres de sortida
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN EXC_NO_CLIENTS THEN
  		RSP:= 'ERROR 150256'; 
    	ERR_DESC:= 'No hi ha clients dins la Base de Dades';
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN EXC_NO_ORDRES THEN
      RSP:= 'ERROR 150257'; 
    	ERR_DESC:= 'No hi ha cap ordre de compra i/o venda durant l''any '||p_any;
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN OTHERS THEN
      RSP:= 'ERROR 150258'; 
    	ERR_DESC:= SQLERRM;
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
END;
/ 
--=================================================================================================
--             3.	Resum dOperacions sobre les accions
--=================================================================================================
/*
L'objectiu del procediment s mostrar un Resum de les ordres executades sobre les ACCIONS duran l'any que s'indiqui en el parmetre
En el llistat noms surten les accions sobre les quals s'hagi realitzat alguna operaci duran l''any indicat
Les dades que es mostren sn el ticker i nom de l'acci, la quantitat d'operacions de compra executades i la quantitat d'operacions de venda executades.
Aix com l'import total i mig d'aquestes operacions.
Per acabar tamb es mostrar la revaloritzaci que ha patit l'acci duran l'any
Es controlen les segents situacions excepcionals:
-	Si lany indicat no t sentit
-	Si no hi ha cap acci a la BD
- Si no s'ha realitzat cap operaci de compra/venda duran l'any indicat
- Si no hi ha els preus de tancament per l'any indicat dins la BD
*/
CREATE OR REPLACE PROCEDURE PROC_3(P_any IN char,RSP OUT VARCHAR2, ERR_DESC  OUT VARCHAR2) IS
cursor c_accions is select ticker,nom from accio;
  type r_nou is record
  (
      qCexe number(4,0), --?	Quantitat doperacions de compra executades
      sumCexe number(38,6), --?	Suma total deuros de les operacions anteriors
      avgCexe number(38,6),--?	Valor mig en euros de les ordres de compra executades
      qVexe number(4,0), --?	Quantitat doperacions de VENDA executades
      sumVexe number(38,6), --?	Suma total deuros de les operacions anteriors
      avgVexe number(38,6),--?	Valor mig en euros de les ordres de VENDA executades (afegit per lautora, no es demanava en lenunciat inicial)
      revalor number(38,6) --?	Revaloritzaci de lacci en percentatge des de l1 de gener de lany indicat
  );
  v_dades r_nou;
  v_qa number(4,0);
  v_qd number(4,0);
  v_sa number(38,6);
  v_sd number(38,6);
  V_DATAINI DATE; -- primer dia de l'any indicat
  V_DATAFI DATE; -- ultim dia de l'any indicat o b data actual
  v_preuINI ACTUALITZAR.PREUTANCAMENT%TYPE; -- PER DESAR EL PREU A 1 DE GENER DE L'ANY INDICAT
  v_preuFI ACTUALITZAR.PREUTANCAMENT%TYPE; -- PER DESAR EL PREU A 31 DE DESEMBRE DE L'ANY INDICAT O B A LA DATA ACTUAL
  v_cadena varchar2(200);
  V_PENTRADA AUDITORIA.PENTRADA%TYPE;
  V_PSORTIDA AUDITORIA.PSORTIDA%TYPE;
  EXC_ANY_ERROR EXCEPTION;
  EXC_NO_accionS EXCEPTION;
  EXC_NO_OPERACIONS EXCEPTION;
begin
  RSP:='OK';
  V_PSORTIDA:=RSP;
  V_PENTRADA:=P_ANY;
  -- ALTA a la taula AUDITORIA d'una nova crida a un procediment
  PROC_ALTA_AUDITORIA ('CONSULTA 3',V_PENTRADA,V_PSORTIDA,RSP);
  IF (P_ANY IS NULL OR P_ANY<'2015' OR P_ANY>'3000') THEN
    RAISE EXC_ANY_ERROR;
  END IF;
  SELECT COUNT(*) INTO V_sd
  FROM ACCIO;
  IF V_SD = 0 THEN
    RAISE EXC_NO_ACCIONS;
  END IF;
  V_DATAINI:=to_date('01/01/'||p_any,'dd/mm/yyyy');
  V_DATAFI:=to_date('31/12/'||p_any,'dd/mm/yyyy');
  select count(*) into v_qa
  from ordre 
  where estat LIKE 'executada' and to_char(dataexecucio,'YYYY')=p_any;
  IF V_QA=0 THEN
    RAISE EXC_NO_OPERACIONS;
  END IF;
  if (v_datafi>sysdate) then
    v_datafi:=TO_char(SYSDATE-1,'dd/mm/yyyy');
  end if; -- ultim dia de l'any indicat o b data actual, menys un dia
    DBMS_OUTPUT.PUT_LINE('---------------------------------------------------------------------------------------------------------------------------------------');
    dbms_output.put_line('                         Resum d''operacions sobre les ACCIONS entre les dates '||v_dataini||' i '||v_datafi);
    DBMS_OUTPUT.PUT_LINE('             en el llistat noms surten les accions sobre les quals s''hagi realitzat alguna operaci duran l''any indicat');
    DBMS_OUTPUT.PUT_LINE('---------------------------------------------------------------------------------------------------------------------------------------');
    DBMS_OUTPUT.PUT_LINE('TICKER         NOM ACCI                                 OPERACIONS DE COMPRA                 OPERACIONS DE VENDA        REVALORITZACI');
    DBMS_OUTPUT.PUT_LINE('---------------------------------------------------------------------------------------------------------------------------------------');
    DBMS_OUTPUT.PUT_LINE('                                                   EXECUTADES - IMPORT - IMPORT MIG     EXECUTADES - IMPORT - IMPORT MIG');
    DBMS_OUTPUT.PUT_LINE('---------------------------------------------------------------------------------------------------------------------------------------');
for r_a in c_accions loop
 -- per les ORDRES DE COMPRA
    -- per les ordres de trading automatic
    select count(*) into v_qa
    from ordre o join t_automatic t on (o.ide_ordre=t.ordre and o.client=t.client)
                join senyal_automatic s on (t.senyal = s.ide_senyal)
    where s.producte like r_a.ticker and o.tipus like 'COMPRA' and o.estat LIKE 'executada' and to_char(o.dataexecucio,'YYYY')=p_any;
    -- per les ordres de trading discrecional
    select count(*) into v_qd
    from ordre o join t_discrecional t on (o.ide_ordre=t.ordre and o.client=t.client)
    where t.accio like r_a.ticker and o.tipus like 'COMPRA' and o.estat LIKE 'executada' and to_char(o.dataexecucio,'YYYY')=p_any;    
    v_dades.qCexe:=v_qa+v_qd;
    if (v_dades.qCexe!=0) then -- si hi ha ordres de compra executades
        if (v_qa!=0) then
          -- per les ordres de trading automatic
          select sum(o.unitats*o.preu) into v_sa
          from ordre o join t_automatic t on (o.ide_ordre=t.ordre and o.client=t.client)
                      join senyal_automatic s on (t.senyal = s.ide_senyal)
          where s.producte like r_a.ticker and o.tipus like 'COMPRA' and o.estat LIKE 'executada' and to_char(o.dataexecucio,'YYYY')=p_any;
        end if;
        if (v_qd!=0) then
          -- per les ordres de trading discrecional
          select sum(o.unitats*o.preu) into v_sd
          from ordre o join t_discrecional t on (o.ide_ordre=t.ordre and o.client=t.client)
          where t.accio like r_a.ticker and o.tipus like 'COMPRA' and o.estat LIKE 'executada' and to_char(o.dataexecucio,'YYYY')=p_any;    
        end if;
      v_dades.sumCexe:=v_sa+v_sd;
      v_dades.avgCexe:=v_dades.sumCexe/v_dades.qCexe;
    else
      v_dades.sumCexe:=0;
      v_dades.avgCexe:=0;
    end if;

 -- per les ORDRES DE VENDA
    -- per les ordres de trading automatic
    select count(*) into v_qa
    from ordre o join t_automatic t on (o.ide_ordre=t.ordre and o.client=t.client)
                join senyal_automatic s on (t.senyal = s.ide_senyal)
    where s.producte like r_a.ticker and o.tipus like 'VENDA' and o.estat LIKE 'executada' and to_char(o.dataexecucio,'YYYY')=p_any;
    -- per les ordres de trading discrecional
    select count(*) into v_qd
    from ordre o join t_discrecional t on (o.ide_ordre=t.ordre and o.client=t.client)
    where t.accio like r_a.ticker and o.tipus like 'VENDA' and o.estat LIKE 'executada' and to_char(o.dataexecucio,'YYYY')=p_any;    
    v_dades.qVexe:=v_qa+v_qd;
    if (v_dades.qVexe!=0) then
        if (v_qa!=0) then
          -- per les ordres de trading automatic
          select sum(o.unitats*o.preu) into v_sa
          from ordre o join t_automatic t on (o.ide_ordre=t.ordre and o.client=t.client)
                      join senyal_automatic s on (t.senyal = s.ide_senyal)
          where s.producte like r_a.ticker and o.tipus like 'VENDA' and o.estat LIKE 'executada' and to_char(o.dataexecucio,'YYYY')=p_any;
        end if;
        if (v_qd!=0) then
          -- per les ordres de trading discrecional
          select sum(o.unitats*o.preu) into v_sd
          from ordre o join t_discrecional t on (o.ide_ordre=t.ordre and o.client=t.client)
          where t.accio like r_a.ticker and o.tipus like 'VENDA' and o.estat LIKE 'executada' and to_char(o.dataexecucio,'YYYY')=p_any;    
        end if;
      v_dades.sumVexe:=v_sa+v_sd;
      v_dades.avgVexe:=v_dades.sumVexe/v_dades.qVexe;
    else
      v_dades.sumVexe:=0;
      v_dades.avgVexe:=0;
    end if;
    -- si hi ha ordres de compra i/o venda sobre l'acci actual es procedeix a fer els calculs finals i mostrar dades en el llistat
    if not (v_dades.qVexe=0 and v_dades.qCexe=0) then
          --Revaloritzaci de lacci en percentatge des de l1 de gener de lany indicat
          select preutancament into v_preuINI
          from actualitzar
          where producte like r_a.ticker and data= v_dataini; -- PER DESAR EL PREU A 1 DE GENER DE L'ANY INDICAT
          select preutancament into v_preuFI 
          from ACTUALITZAR  
          where producte like r_a.ticker and data = v_datafi; -- PER DESAR EL PREU A 31 DE DESEMBRE DE L'ANY INDICAT O B A LA DATA ACTUAL
          IF v_preuINI = 0 then
            v_dades.revalor:=0;
          else
            v_dades.revalor:= (v_preuFI-v_preuINI) * 100 / v_preuINI;
          END IF;
          v_cadena:=rpad(r_a.ticker,8)||' '||rpad(r_a.nom,40)||' '||lpad(v_dades.qCexe,5)||' ';
          if v_dades.qCexe=0 then
              v_cadena:=v_cadena||LPAD(' ',14)||' '||LPAD(' ',12)||' '; 
          else
              v_cadena:=v_cadena||LPAD(TO_CHAR(v_dades.sumCexe,'99G999D99'),14)||' '||LPAD(TO_CHAR(v_dades.avgCexe,'99G999D99'),12)||' ';   
          end if;
          v_cadena:=v_cadena||lpad(v_dades.qVexe,10)||' ';
          if (v_dades.qVexe=0) then
              v_cadena:=v_cadena||LPAD(' ',14)||' '||LPAD(' ',12)||' '||lpad(to_char(v_dades.revalor,'999D9999'),10);
          else
              v_cadena:=v_cadena||LPAD(TO_CHAR(v_dades.sumVexe,'99G999D99'),14)||' '||LPAD(TO_CHAR(v_dades.avgVexe,'99G999D99'),12)||' '||lpad(to_char(v_dades.revalor,'999D9999'),10);
          end if;
          dbms_output.put_line(v_cadena);
    end if;          
end loop;
EXCEPTION
  WHEN EXC_ANY_ERROR THEN
  		RSP:= 'ERROR 150259'; 
    	ERR_DESC:= 'L''any indicat no s valid per la informaci que hi ha dins la BD';
		-- Actualitzem la taula AUDITORIA amb el valor dels parmetres de sortida
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN EXC_NO_ACCIONS THEN
  		RSP:= 'ERROR 150260'; 
    	ERR_DESC:= 'No hi ha accions dins la Base de Dades';
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN NO_DATA_FOUND THEN
      RSP:= 'ERROR 150261'; 
    	ERR_DESC:= 'No hi ha cap informaci dins la taula ACTUALITZAR de la Base de dades';
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
  WHEN EXC_NO_OPERACIONS THEN
      RSP:= 'ERROR 150262'; 
    	ERR_DESC:= 'No s''ha executat cap operaci duran l''any '||p_any;
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);  
  WHEN OTHERS THEN
      RSP:= 'ERROR 150263'; 
    	ERR_DESC:= SQLERRM;
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
end;
/
--=================================================================================================
--             4.	Top ten
--=================================================================================================
-- Les deu accions ms adquirides pels sistemes automtics, ordenades de forma decreixent pel seu volum.
-- s a dir, el nmero d'accions que s'han comprat amb sistemes de trading automtics
-- Cas que no hi hagi 10 accions adquirides mitjanant sistemes de trading automtics, es mostraran les que hi hagi.
-- S'ha decidit tenir present tamb les compres que s'hagin donat de baixa, doncs, en el seu moment es van
-- portar a terme i per tant formen part del volum de compres.
CREATE OR REPLACE PROCEDURE PROC_4 (RSP OUT VARCHAR2, ERR_DESC  OUT VARCHAR2) IS
type tr_top is record
(
  ticker accio.ticker%type,
  nom    accio.nom%type,
  volum  ordre.unitats%type
);
cursor c_top10 is select s.producte as ticker, rpad(ac.nom,50) as nom, sum (o.unitats) as volum
          from ordre o join t_automatic t on (o.ide_ordre=t.ordre and o.client=t.client) 
                        join senyal_automatic s on (t.senyal=s.ide_senyal)
                        join accio ac on (s.producte=ac.ticker)
          where o.tipus like 'COMPRA' -- and o.activasn='Y'
          and o.estat like 'executada'
          group by s.producte,ac.nom
          order by 3 desc;
  v_q number:=0;
  r_top tr_top;
  V_PENTRADA AUDITORIA.PENTRADA%TYPE;
  V_PSORTIDA AUDITORIA.PSORTIDA%TYPE;
begin
    RSP:='OK';
    V_PSORTIDA:=RSP;
    V_PENTRADA:=null;
    -- ALTA a la taula AUDITORIA d'una nova crida a un procediment
    PROC_ALTA_AUDITORIA ('CONSULTA 4',V_PENTRADA,V_PSORTIDA,RSP);
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------------');
    dbms_output.put_line('TOP TEN -> Les accions ms adquirides amb TRADINGS AUTOMTICS');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------------');
    DBMS_OUTPUT.PUT_LINE('TICKER          NOM ACCI                       TOTAL UNITATS COMPRADES');
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------------');
    open c_top10;
        loop
          fetch c_top10 INTO r_top;
          exit when c_top10%notfound or c_top10%rowcount>10;
          dbms_output.put_line(lpad(v_q+1,2)||'. '||rpad(R_TOP.TICKER,7)||' '||rpad(R_TOP.NOM,45)||' '||lpad(R_TOP.VOLUM,4));
          v_q:=v_q+1;
        end loop;
      close c_top10;
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------------');
      IF (V_Q=0) THEN
        DBMS_OUTPUT.PUT_LINE('No hi ha dades a mostrar');
      ELSIF (V_Q<10) THEN
        DBMS_OUTPUT.PUT_LINE('Noms hi ha '||v_q||' accions adquirides amb TRADINGS AUTOMTICS');  
      ELSE
        DBMS_OUTPUT.PUT_LINE('Aquestes sn les '||v_q||' accions ms adquirides amb TRADINGS AUTOMTICS');  
      END IF;
    DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------------------');
EXCEPTION
  WHEN OTHERS THEN
      RSP:= 'ERROR 150264'; 
    	ERR_DESC:= SQLERRM;
      PROC_MODIF_AUDITORIA (SEQ_LOG.CURRVAL,'KO', RSP||' '||ERR_DESC);
    	DBMS_OUTPUT.PUT_LINE(RSP||' '||ERR_DESC);
end;
/ 