--========================================================================================
--------------------------- ESBORRAT DE LES TAULES ----------------------------------------
--========================================================================================
--------------------- TAULES DEL MDUL D'ESTADSTIQUES --------------------------------
DROP TABLE EST_ACCIOMESNEGO;
DROP TABLE EST_BEST_CLIENT;
DROP TABLE EST_MES_CLIENT;
DROP TABLE AUDITORIA;
--------------------- TAULES DE LA BASE DE DADES --------------------------------
DROP TABLE SUBSCRIPCIO;
DROP TABLE CARTERA;
DROP TABLE ACTUALITZAR;
DROP TABLE T_AUTOMATIC;
DROP TABLE T_DISCRECIONAL;
DROP TABLE ORDRE;
DROP TABLE SENYAL_AUTOMATIC;
DROP TABLE ACCIO;
DROP TABLE INDEX_BORSARI;
DROP TABLE MERCAT_FINANCER;
DROP TABLE BORSA;
DROP TABLE CLIENT;
DROP TABLE CIUTAT;
DROP TABLE PAIS;
--========================================================================================
---------------------------- ESBORRAR LES SEQNCIES -------------------------------------
--========================================================================================
DROP SEQUENCE SEQ_LOG;
DROP SEQUENCE SEQ_PAIS;
DROP SEQUENCE SEQ_CLIENT;
DROP SEQUENCE SEQ_SENYAL;
--========================================================================================
------------------------------ CREACI DE SEQNCIES -------------------------------------
--========================================================================================
CREATE SEQUENCE SEQ_LOG INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE SEQ_PAIS INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE SEQ_CLIENT INCREMENT BY 1 START WITH 1;
CREATE SEQUENCE SEQ_SENYAL INCREMENT BY 1 START WITH 1;
--========================================================================================
--------------------------- CREACI DE LES TAULES ----------------------------------------
--========================================================================================
CREATE TABLE PAIS
(
IDE_PAIS NUMBER(6) CONSTRAINT PK_PAIS PRIMARY KEY,
NOM VARCHAR2(100) CONSTRAINT NN_PAIS_NOM NOT NULL
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI ;
  
CREATE TABLE CIUTAT
(
IDE_CIUTAT NUMBER(6),
PAIS NUMBER(6) CONSTRAINT FK_CIUTAT_PAIS REFERENCES PAIS CONSTRAINT NN_CIUTAT_PAIS NOT NULL,
NOM VARCHAR2(100) CONSTRAINT NN_CIUTAT_NOM NOT NULL,
CONSTRAINT PK_CIUTAT PRIMARY KEY (IDE_CIUTAT,PAIS)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI ;
  
CREATE TABLE CLIENT
(
IDE_CLIENT number(6) constraint pk_CLIENT primary key,
NIF VARCHAR2(9) CONSTRAINT SK_CLIENT UNIQUE 
                CONSTRAINT NN_CLIENT_NIF NOT NULL 
                CONSTRAINT CHK_CLIENT_NIF CHECK (SUBSTR(NIF,1,8) BETWEEN 0 AND 99999999  AND SUBSTR(NIF,9,1) BETWEEN 'A' AND 'Z' AND LENGTH(NIF)=9),
nom VARCHAR2(20) constraint nn_CLIENT_NOM NOT NULL,
cognoms VARCHAR2(100) constraint nn_CLIENT_COGNOMS NOT NULL, 
DATANAIX DATE constraint nn_CLIENT_D_NAIX NOT NULL 
              constraint chk_CLIENT_datanaix check (to_char(datanaix,'yyyy')>='1900'),

DATAALTA DATE constraint nn_CLIENT_D_ALTA NOT NULL
              constraint chk_CLIENT_dataALTA check (to_char(dataALTA,'yyyy')>='2015'),
ADRESA VARCHAR2(100) constraint nn_CLIENT_ADREA NOT NULL,
CP CHAR(5) constraint nn_CLIENT_CP NOT NULL, 
TELEFON VARCHAR2(13) constraint nn_CLIENT_TELEFON NOT NULL
                     CONSTRAINT CHK_CLIENT_TELEFON CHECK (TELEFON >=0 AND TELEFON<=999999999 and length(TELEFON)=9),
EMAIL VARCHAR2(50) constraint nn_CLIENT_MAIL NOT NULL 
                  CONSTRAINT CHK_CLIENT_EMAIL CHECK (REGEXP_LIKE (email,'^\w+(\.\w+)*+@\w+(\.\w+)+$')),
ACTIVATSN char(1) default 'Y' constraint nn_CLIENT_activat NOT NULL 
                  constraint CHK_CLIENT_ACTIVAT CHECK (ACTIVATSN IN ('Y','N')), 
CIUTAT NUMBER(6) constraint nn_CLIENT_CIUTAT NOT NULL,
PAIS NUMBER(6) constraint nn_CLIENT_PAIS NOT NULL,
VALORACTUALCARTERA NUMBER(38,6) DEFAULT 0 CONSTRAINT NN_CLIENT_VALORCARTERA NOT NULL,
CONSTRAINT FK_CLIENT_CIUTAT_PAIS FOREIGN KEY (CIUTAT,PAIS) REFERENCES CIUTAT(IDE_CIUTAT,PAIS)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

CREATE TABLE BORSA
(
IDE_BORSA VARCHAR2(20) CONSTRAINT PK_BORSA PRIMARY KEY,
DESCRIPCIO VARCHAR2(200) CONSTRAINT NN_BORSA_DESCRIPCIO NOT NULL,
CIUTAT NUMBER(6) CONSTRAINT NN_BORSA_CIUTAT NOT NULL,
PAIS NUMBER(6) CONSTRAINT NN_BORSA_PAIS NOT NULL,
CONSTRAINT FK_BORSA_CIUTAT_PAIS FOREIGN KEY (CIUTAT,PAIS) REFERENCES CIUTAT(IDE_CIUTAT,PAIS)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

CREATE TABLE MERCAT_FINANCER
(
IDE_MERCAT VARCHAR2(10) CONSTRAINT PK_MERCAT_FINANCER PRIMARY KEY,
DESCRIPCIO VARCHAR2(200) CONSTRAINT NN_MERCAT_DESCRIPCIO NOT NULL,
BORSA VARCHAR2(20) CONSTRAINT FK_MERCAT_FINANCER_BORSA REFERENCES BORSA CONSTRAINT NN_MERCAT_BORSA NOT NULL
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI; 

CREATE TABLE INDEX_BORSARI
(
IDE_INDEX VARCHAR2(10) CONSTRAINT PK_INDEX_BORSARI PRIMARY KEY,
DESCRIPCIO VARCHAR2(200) CONSTRAINT NN_INDEX_DESCRIPCIO NOT NULL,
MERCATFINANCER VARCHAR2(10) CONSTRAINT FK_INDEX_BORSARI REFERENCES MERCAT_FINANCER CONSTRAINT NN_INDEX_MERCAT NOT NULL
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

CREATE TABLE ACCIO
(
TICKER VARCHAR2(20) CONSTRAINT PK_ACCIO PRIMARY KEY,
NOM VARCHAR2(200)  CONSTRAINT NN_ACCIO_NOM NOT NULL, -- NOM COMPLET DE L'ACCI
DESCRIPCIO VARCHAR(1000) CONSTRAINT NN_ACCIO_DESCRIPCIO NOT NULL, -- DESCRIPCI DE L'EMPRESA A LA QUE PERTANY L'ACCI
INDEXBORSARI VARCHAR2(10) CONSTRAINT FK_ACCIO_INDEX_BORSA REFERENCES INDEX_BORSARI CONSTRAINT NN_ACCIO_INDEX NOT NULL,
UNITATSENVENDA NUMBER(38,0) DEFAULT 0 CONSTRAINT CHK_ACCIO_UNITATS CHECK (UNITATSENVENDA>=0) CONSTRAINT NN_ACCIO_U_NEGOCIA NOT NULL, -- s el nmero daccions disponibles, s a dir, suma de totes les accions que estan en ordres de venda en estat 'Pendent'.
QPROPIETARIS NUMBER(3,0) DEFAULT 0 CONSTRAINT CHK_ACCIO_QPROPIETARIS CHECK (QPROPIETARIS>=0) CONSTRAINT NN_ACCIO_QPROPIET NOT NULL -- Aquest atribut s imprescindible pel mdul d'estadstiques; s la quantitat de clients que tenen lacci en la seva cartera
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

CREATE TABLE SENYAL_AUTOMATIC
(
IDE_SENYAL NUMBER(6) CONSTRAINT PK_SENYAL_AUTOMATIC PRIMARY KEY,
DATAALTA DATE CONSTRAINT NN_SENYAL_DATALTA NOT NULL,
INIVIGENCIA DATE CONSTRAINT NN_SENYAL_INIVIGENCIA NOT NULL,
FIVIGENCIA DATE CONSTRAINT NN_SENYAL_FIVIGENCIA NOT NULL,
PRODUCTE VARCHAR2(20) CONSTRAINT FK_SENYAL_AUTOMATIC_PRODUCTE REFERENCES ACCIO CONSTRAINT NN_SENYAL_PRODUCTE NOT NULL,
CONSTRAINT CHK_SENYA_AUTOMATIC_VIGENCIA CHECK (INIVIGENCIA<FIVIGENCIA AND DATAALTA<=INIVIGENCIA)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

CREATE TABLE ORDRE 
(
IDE_ORDRE NUMBER(6),
CLIENT NUMBER(6) CONSTRAINT FK_ORDRE_CLIENT REFERENCES CLIENT,
DATAENTRADA DATE NOT NULL,
TIPUS VARCHAR2(6) NOT NULL CONSTRAINT CHK_ORDRE_TIPUS CHECK (TIPUS IN ('COMPRA','VENDA')),
TRADING CHAR(1) CONSTRAINT NN_ORDRE_TRADING NOT NULL CONSTRAINT CHK_ORDRE_TRADING CHECK (TRADING IN ('D','A')),
ESTAT VARCHAR2(11) NOT NULL CONSTRAINT CHK_ORDRE_ESTAT CHECK (ESTAT IN ('pendent','executada','cancelada')),
DATAEXECUCIO DATE, 
DATACANCELACIO DATE, 
PREU NUMBER(38,6),
UNITATS NUMBER(20) CONSTRAINT NN_ORDRE_UNITATS NOT NULL,
PREUMINIM NUMBER(38,6), 
ACTIVASN CHAR(1) DEFAULT 'Y' CONSTRAINT NN_ORDRE_ACTIVA NOT NULL CONSTRAINT CHK_ORDRE_ACTIVA CHECK (ACTIVASN IN ('Y','N')),
CONSTRAINT PK_ORDRE PRIMARY KEY (IDE_ORDRE,CLIENT),
CONSTRAINT CHK_ORDRE_DATES CHECK (DATAENTRADA<=DATAEXECUCIO AND DATAENTRADA<=DATACANCELACIO)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

CREATE TABLE T_AUTOMATIC
(
ordre NUMBER(6),
CLIENT NUMBER(6),
senyal NUMBER(6) CONSTRAINT FK_T_AUTOMATIC_SENYAL REFERENCES SENYAL_AUTOMATIC(IDE_SENYAL) CONSTRAINT NN_T_AUTOMATIC_SENYAL NOT NULL,
CONSTRAINT PK_T_AUTOMATIC PRIMARY KEY (ORDRE,CLIENT),
CONSTRAINT FK_T_AUTOMATIC_ORDRE FOREIGN KEY (ORDRE,CLIENT) REFERENCES ORDRE(IDE_ORDRE,CLIENT)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

CREATE TABLE T_DISCRECIONAL
(
ordre NUMBER(6),
CLIENT NUMBER(6),
accio VARCHAR2(20) CONSTRAINT FK_T_DISCRECIONAL_ACCIO REFERENCES ACCIO CONSTRAINT NN_T_DISCRECIONAL_ACCIO NOT NULL,
CONSTRAINT PK_T_DISCRECIONAL PRIMARY KEY (ORDRE,CLIENT)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

CREATE TABLE CARTERA
(
PRODUCTE VARCHAR2(20) CONSTRAINT FK_CARTERA_ACCIO REFERENCES ACCIO,
DATA DATE,
CLIENT NUMBER(6) CONSTRAINT FK_CARTERA_CLIENT REFERENCES CLIENT,
UNITATS NUMBER(38,0) CONSTRAINT NN_CARTERA_UNITATS NOT NULL,
UNITATSDISPONIBLES NUMBER(38,0) CONSTRAINT NN_CARTERA_UNITATSDISPONIBLES NOT NULL,
ACTIVASN CHAR(1) DEFAULT 'Y' CONSTRAINT NN_CARTERA_ACTIVA NOT NULL CONSTRAINT CHK_CARTERA_ACTIVA CHECK (ACTIVASN IN ('Y','N')),
CONSTRAINT PK_CARTERA PRIMARY KEY (CLIENT,PRODUCTE,DATA),
CONSTRAINT CHK_CARTERA_UNITATS CHECK (UNITATS>=UNITATSDISPONIBLES)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI; 

CREATE TABLE ACTUALITZAR
(
PRODUCTE VARCHAR2(20) CONSTRAINT FK_APREUS_TANCAMENT_ACCIO REFERENCES ACCIO,
DATA DATE,
PREUTANCAMENT NUMBER(38,6) CONSTRAINT NN_ACTUALITZAR_PREU NOT NULL,
CONSTRAINT PK_ACTUALITZAR PRIMARY KEY (PRODUCTE,DATA)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

CREATE TABLE SUBSCRIPCIO
(
CLIENT number(6) CONSTRAINT FK_SUBSCRIPCIO_CLIENT REFERENCES CLIENT,
SENYAL NUMBER(6) CONSTRAINT FK_SUBSCRIPCIO_SENYAL REFERENCES SENYAL_AUTOMATIC,
DATA DATE CONSTRAINT NN_SUBSCRIPCIO_DATA NOT NULL,
CONSTRAINT PK_SUBSCRIPCIO PRIMARY KEY (CLIENT,SENYAL)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;
--------------------- TAULES DEL MDUL D'ESTADSTIQUES --------------------------------
create table EST_ACCIOMESNEGO
(
accio varchar2(20) constraint fk_est_accioMesNego references ACCIO(ticker),
data date,
unitatsNegociades number(38,0) DEFAULT 0 CONSTRAINT CHK_EST_ACCIOMESNEGO CHECK (UNITATSNEGOCIADES>=0) CONSTRAINT NN_EST_ACCIOMESNEGO NOT NULL,
constraint pk_est_accioMesNego primary key (accio,data)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

create table EST_BEST_CLIENT
(
data date,
client number(6) constraint fk_est_best_client references CLIENT(IDE_CLIENT),
valorCartera number(38,6) DEFAULT 0 CONSTRAINT CHK_EST_BEST_CLIENT CHECK (VALORCARTERA>=0) CONSTRAINT NN_EST_BEST_CLIENT NOT NULL,
constraint pk_est_best_client primary key (data,client)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

create table EST_MES_CLIENT
(
client number(6) constraint FK_est_mes_client references CLIENT(IDE_CLIENT),
anny number(4,0) CONSTRAINT CHK_EST_MES_CLIENT_ANY CHECK (ANNY>2014),
mes varchar2(15) CONSTRAINT CHK_EST_MES_CLIENT_MES CHECK (MES IN ('GENER','FEBRER','MAR','ABRIL','MAIG','JUNY','JULIOL','AGOST','SETEMBRE','OCTUBRE','NOVEMBRE','DESEMBRE')),
p100Benefici number(5,2) DEFAULT 0 CONSTRAINT NN_EST_MES_CLIENT_P100 NOT NULL,
valorIniCartera number(38,6) DEFAULT 0 CONSTRAINT CHK_MES_BEST_CLIENT_VINI CHECK (VALORINICARTERA>=0) CONSTRAINT NN_EST_MES_CLIENT_INI NOT NULL,
valorFiCartera number(38,6) DEFAULT 0 CONSTRAINT CHK_EST_MES_CLIENT_VFI CHECK (VALORFICARTERA>=0) CONSTRAINT NN_EST_MES_CLIENT_FI NOT NULL,
constraint pk_est_mes_client primary key (client,anny,mes)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;

create table AUDITORIA
(
IDE_AUDITORIA NUMBER(10) constraint pk_auditoria primary key,
data date,
procediment varchar2(100),
pentrada varchar2(1000),
pSORTIDA varchar2(100),
resultatExecucio varchar2(600)
) SEGMENT CREATION IMMEDIATE 
  PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE BROKER_ESPAI;
--========================================================================================
------------------------------- CREACI D'NDEXOS ----------------------------------------
--========================================================================================
CREATE INDEX "SENYAL_AUTOMATIC+ACCIO" ON SENYAL_AUTOMATIC (IDE_SENYAL,PRODUCTE);
CREATE INDEX "ORDRE+TRADING+TIPUS+ESTAT" ON ORDRE (IDE_ORDRE,CLIENT,TRADING,TIPUS,ESTAT);
